// Name: main.c
// char    MYD_id[]=
// " sphMtest.C Ver.050 2010/09/18  MORIYOSHI DENSHI CO.,LTD. COPYRIGHT(C) OCT.2009 ";
// License: GNU GPL v2
// avr ATmega168 12MHz
// fuse L:E0(11100000) H:DF(11011111) E:01(00000001) // External Clock
//   or L:C0(11100000) H:DD(11011111) E:01(00000001) // External Clock(BOD on)
// fuse L:FF(11111111) H:DF(11011111) E:01(00000001) // XTAL
//   or L:CF(11001111) H:DF(11011111) E:01(00000001) // CEROLOCK

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <string.h>

#ifndef uchar
#define uchar   unsigned char
#endif

#define WORD unsigned int

uchar consts, conibf[3];
uchar ussphsts;

void  coninit() {
    // initialize hardware
    PORTB = 0x87;    // all pullups except PB5,4,3. PB6 external clock
    DDRB = 0;        // all inputs //@include PB1(~RTS) except PB4(~CTS) output
    PORTC = 0x3F;    // all pullups. PC6 cpu reset
    DDRC = 0;        // all inputs
    PORTD = 0xFF;    // all pullups
    DDRD = 0;        // all inputs
    //@DDRD = (1<<PD1); // all inputs include RXD(PD0 TxD) except TXD(PD1 RxD)

    // USART configuration : 9600bps 8N1
    /*UBRR0L  = 78-1;
    UCSR0B  = (1<<RXEN0) | (1<<TXEN0) | (1<<RXCIE0);*/
    consts = 0;
    ussphsts = 0x40;
}

uchar getsphsts(void) { uchar slvsts, i;
    //conout('g');
t1: DDRB &= ~(1<<PB5); // SCL <-- Open  // get SPH status
    while( !(PINB & (1<<PB5)) ) DDRB &= ~(1<<PB5); // SCL <-- Open
    DDRB |= (1<<PB5); // SCL <-- Low
    DDRB &= ~(1<<PB4); // SDA <-- Open
    DDRB &= ~(1<<PB4); // SDA <-- Open
    if( !(PINB & (1<<PB4)) ) goto t1; // SDA==0
    DDRB &= ~(1<<PB5); // SCL <-- Open
    while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
    DDRB |= (1<<PB5); // SCL <-- Low
    DDRB &= ~(1<<PB4); // SDA <-- Open
    if( !(PINB & (1<<PB4)) ) goto t1; // SDA==0
    DDRB &= ~(1<<PB5); // SCL <-- Open
    while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
    DDRB |= (1<<PB4); // SDA <-- Low
    DDRB |= (1<<PB4); // SDA <-- Low
    DDRB |= (1<<PB5); // SCL <-- Low, Start Condition
    DDRB &= ~(1<<PB4); // SDA <-- Open
    slvsts = 0;
    for(i=8; i--;) {
        DDRB &= ~(1<<PB5); // SCL <-- Open
        while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
        slvsts <<= 1;
        if(PINB & (1<<PB4)) slvsts |= 1;
        DDRB |= (1<<PB5); // SCL <-- Low
    }
    while( !(PINB & (1<<PB4)) ) ; // wait for SDA==1
    DDRB &= ~(1<<PB5); // SCL <-- Open
    return slvsts;
}

uchar getsphdat(void) { uchar slvdat, i;
t2: DDRB &= ~(1<<PB5); // SCL <-- Open  // get SPH data
    while( !(PINB & (1<<PB5)) ) DDRB &= ~(1<<PB5); // SCL <-- Open
    DDRB |= (1<<PB5); // SCL <-- Low
    DDRB |= (1<<PB5); // SCL <-- Low
    DDRB |= (1<<PB4); // SDA <-- Low
    DDRB |= (1<<PB4); // SDA <-- Low
    DDRB &= ~(1<<PB5); // SCL <-- Open
    while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
    DDRB |= (1<<PB5); // SCL <-- Low
    DDRB &= ~(1<<PB4); // SDA <-- Open
    DDRB &= ~(1<<PB4); // SDA <-- Open
    if( !(PINB & (1<<PB4)) ) goto t2; // SDA==0
    DDRB &= ~(1<<PB5); // SCL <-- Open
    while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
    DDRB |= (1<<PB4); // SDA <-- Low
    DDRB |= (1<<PB4); // SDA <-- Low
    DDRB |= (1<<PB5); // SCL <-- Low, Start Condition
    DDRB &= ~(1<<PB4); // SDA <-- Open
    slvdat = 0;
    for(i=8; i--;) {
        DDRB &= ~(1<<PB5); // SCL <-- Open
        while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
        slvdat <<= 1;
        if(PINB & (1<<PB4)) slvdat |= 1;
        DDRB |= (1<<PB5); // SCL <-- Low
    }
    while( !(PINB & (1<<PB4)) ) ; // wait for SDA==1
    DDRB &= ~(1<<PB5); // SCL <-- Open
    return slvdat;
}

void putsphdat(uchar slvdat) { uchar txdtmp, i;
t3: DDRB &= ~(1<<PB5); // SCL <-- Open  // put data to SPH
    while( !(PINB & (1<<PB5)) ) DDRB &= ~(1<<PB5); // SCL <-- Open
    DDRB |= (1<<PB5); // SCL <-- Low
    DDRB |= (1<<PB5); // SCL <-- Low
    if( !(PINB & (1<<PB4)) ) goto t3; // SDA==0
    DDRB |= (1<<PB4); // SDA <-- Low
    DDRB |= (1<<PB4); // SDA <-- Low
    DDRB &= ~(1<<PB5); // SCL <-- Open
    while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
    DDRB &= ~(1<<PB4); // SDA <-- Open, Stop Condition
    DDRB &= ~(1<<PB4); // SDA <-- Open
    if( !(PINB & (1<<PB4)) ) goto t3; // SDA==0
    txdtmp = slvdat;
    for(i=8; i--;) {
        DDRB |= (1<<PB5); // SCL <-- Low
        if(txdtmp & 0x80) {
            DDRB &= ~(1<<PB4); // SDA <-- Open
            DDRB &= ~(1<<PB4); // SDA <-- Open
            if( !(PINB & (1<<PB4)) ) goto t3; // SDA==0
        }else{
            DDRB |= (1<<PB4); // SDA <-- Low
        }
        txdtmp <<= 1;
        DDRB &= ~(1<<PB5); // SCL <-- Open
        while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
    }
    DDRB &= ~(1<<PB4); // SDA <-- Open
    DDRB &= ~(1<<PB4); // SDA <-- Open
    if( !(PINB & (1<<PB4)) ) goto t3; // SDA==0
    DDRB |= (1<<PB4); // SDA <-- Low
    DDRB |= (1<<PB4); // SDA <-- Low
    DDRB |= (1<<PB5); // SCL <-- Low, Start Condition
    DDRB &= ~(1<<PB4); // SDA <-- Open
    DDRB &= ~(1<<PB4); // SDA <-- Open
    if( !(PINB & (1<<PB4)) ) goto t3; // SDA==0
    DDRB &= ~(1<<PB5); // SCL <-- Open
    while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
}

void conintr() {
    if( (ussphsts & (1<<6)) || (consts < 3) ) {
        ussphsts = getsphsts() ^ 0xC0;
        if(ussphsts & (1<<7)) {
            if(consts < 3) {
                conibf[consts++] = getsphdat();
            }
        }
    }
}

uchar conins() { // return val. : ready
    conintr();
    return consts;
}

uchar coninp() { uchar dat;
    while( !conins()) ;
    dat = conibf[0];
    conibf[0] = conibf[1];
    conibf[1] = conibf[2];
    --consts;
    return dat;
}

uchar conots() { // return val. : busy
    if( !(ussphsts & (1<<6)) ) return 0;
    conintr();
    return (ussphsts & (1<<6));
}

void  conout(uchar dat) {
    while( conots()) ;
    putsphdat(dat);
    ussphsts |= (1<<6);
}

void  crlf() {
//  conout('\r'); // 0x0D enter
    conout('\n'); // 0x0A ^J
}

void  hxd(uchar dat) {
    dat &= 0x0F;
    if(dat >= 10) dat += ('A'-'0'-10);
    conout(dat + '0');
}

void  lbyte(uchar dat) {
    hxd(dat >> 4);
    hxd(dat);
}

void  ladr(WORD dat) {
    lbyte(dat >> 8);
    lbyte(dat & 0x00FF);
}

void  mesot(char *str) { uchar dat;
    while(1) {
        dat = pgm_read_byte(str);
        if(!dat) break;
        conout(dat);
        str++;
    }
}

uchar txtin() { uchar dat;
    dat = coninp();
    if(dat < 0x20) return dat; // control code
    conout(dat);
    if(dat >= 'a' && dat < 'z'+1) dat -= 'a'-'A';
    return dat;
}

uchar nibbl(uchar dat) {
    dat -= '0';
    if(dat < 10) return dat;
    dat += '0'-'A'+10;
    if(dat >= 10 && dat < 16) return dat;
    return 0x10;
}

extern uchar setdlmnbl(uchar *delmt, uchar ch);
/*uchar setdlmnbl(uchar *delmt, uchar ch) {
    *delmt = ch;
    return nibbl(ch);
}*/

WORD  expr1(uchar *delmt) { WORD dat; uchar ch;
    dat = 0;
    while(1) {
        ch = txtin();
//      *delmt = ch;
//      ch = nibbl(ch);
        ch = setdlmnbl(delmt, ch);
        if(ch >= 0x10) break;
        dat <<= 4;
        dat |= ch;
    }
    return dat;
}

uchar getslvsts(void) { uchar slvsts, i;
    //conout('g');
t1: DDRB &= ~(1<<PB5); // SCL <-- Open  // get slave status
    while( !(PINB & (1<<PB5)) ) DDRB &= ~(1<<PB5); // SCL <-- Open
    DDRB |= (1<<PB5); // SCL <-- Low
    DDRB &= ~(1<<PB3); // SDA <-- Open
    DDRB &= ~(1<<PB3); // SDA <-- Open
    if( !(PINB & (1<<PB3)) ) goto t1; // SDA==0
    DDRB &= ~(1<<PB5); // SCL <-- Open
    while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
    DDRB |= (1<<PB5); // SCL <-- Low
    DDRB &= ~(1<<PB3); // SDA <-- Open
    if( !(PINB & (1<<PB3)) ) goto t1; // SDA==0
    DDRB &= ~(1<<PB5); // SCL <-- Open
    while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
    DDRB |= (1<<PB3); // SDA <-- Low
    DDRB |= (1<<PB3); // SDA <-- Low
    DDRB |= (1<<PB5); // SCL <-- Low, Start Condition
    DDRB &= ~(1<<PB3); // SDA <-- Open
    slvsts = 0;
    for(i=8; i--;) {
        DDRB &= ~(1<<PB5); // SCL <-- Open
        while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
        slvsts <<= 1;
        if(PINB & (1<<PB3)) slvsts |= 1;
        DDRB |= (1<<PB5); // SCL <-- Low
    }
    while( !(PINB & (1<<PB3)) ) ; // wait for SDA==1
    DDRB &= ~(1<<PB5); // SCL <-- Open
    return slvsts;
}

uchar getslvdat(void) { uchar slvdat, i;
t2: DDRB &= ~(1<<PB5); // SCL <-- Open  // get slave data
    while( !(PINB & (1<<PB5)) ) DDRB &= ~(1<<PB5); // SCL <-- Open
    DDRB |= (1<<PB5); // SCL <-- Low
    DDRB |= (1<<PB5); // SCL <-- Low
    DDRB |= (1<<PB3); // SDA <-- Low
    DDRB |= (1<<PB3); // SDA <-- Low
    DDRB &= ~(1<<PB5); // SCL <-- Open
    while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
    DDRB |= (1<<PB5); // SCL <-- Low

    DDRB |= (1<<PB5); // SCL <-- Low
    DDRB &= ~(1<<PB5); // SCL <-- Open
    while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
    DDRB |= (1<<PB5); // SCL <-- Low

    DDRB &= ~(1<<PB3); // SDA <-- Open
    DDRB &= ~(1<<PB3); // SDA <-- Open
    if( !(PINB & (1<<PB3)) ) goto t2; // SDA==0
    DDRB &= ~(1<<PB5); // SCL <-- Open
    while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
    DDRB |= (1<<PB3); // SDA <-- Low
    DDRB |= (1<<PB3); // SDA <-- Low
    DDRB |= (1<<PB5); // SCL <-- Low, Start Condition
    DDRB &= ~(1<<PB3); // SDA <-- Open
    slvdat = 0;
    for(i=8; i--;) {
        DDRB &= ~(1<<PB5); // SCL <-- Open
        while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
        slvdat <<= 1;
        if(PINB & (1<<PB3)) slvdat |= 1;
        DDRB |= (1<<PB5); // SCL <-- Low
    }
    while( !(PINB & (1<<PB3)) ) ; // wait for SDA==1
    DDRB &= ~(1<<PB5); // SCL <-- Open
    return slvdat;
}

void putslvdat(uchar slvdat) { uchar txdtmp, i;
t3: DDRB &= ~(1<<PB5); // SCL <-- Open  // put data to slave
    while( !(PINB & (1<<PB5)) ) DDRB &= ~(1<<PB5); // SCL <-- Open
    DDRB |= (1<<PB5); // SCL <-- Low
    DDRB |= (1<<PB5); // SCL <-- Low
    if( !(PINB & (1<<PB3)) ) goto t3; // SDA==0
    DDRB |= (1<<PB3); // SDA <-- Low
    DDRB |= (1<<PB3); // SDA <-- Low
    DDRB &= ~(1<<PB5); // SCL <-- Open
    while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
    DDRB &= ~(1<<PB3); // SDA <-- Open, Stop Condition
    DDRB &= ~(1<<PB3); // SDA <-- Open
    if( !(PINB & (1<<PB3)) ) goto t3; // SDA==0
    txdtmp = slvdat;
    for(i=8; i--;) {
        DDRB |= (1<<PB5); // SCL <-- Low
        if(txdtmp & 0x80) {
            DDRB &= ~(1<<PB3); // SDA <-- Open
            DDRB &= ~(1<<PB3); // SDA <-- Open
            if( !(PINB & (1<<PB3)) ) goto t3; // SDA==0
        }else{
            DDRB |= (1<<PB3); // SDA <-- Low
        }
        txdtmp <<= 1;
        DDRB &= ~(1<<PB5); // SCL <-- Open
        while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
    }
    DDRB &= ~(1<<PB3); // SDA <-- Open
    DDRB &= ~(1<<PB3); // SDA <-- Open
    if( !(PINB & (1<<PB3)) ) goto t3; // SDA==0
    DDRB |= (1<<PB3); // SDA <-- Low
    DDRB |= (1<<PB3); // SDA <-- Low
    DDRB |= (1<<PB5); // SCL <-- Low, Start Condition
    DDRB &= ~(1<<PB3); // SDA <-- Open
    DDRB &= ~(1<<PB3); // SDA <-- Open
    if( !(PINB & (1<<PB3)) ) goto t3; // SDA==0
    DDRB &= ~(1<<PB5); // SCL <-- Open
    while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
}

void putslvcmnd(uchar slvdat) { uchar txdtmp, i;
t4: DDRB &= ~(1<<PB5); // SCL <-- Open  // put data to slave
    while( !(PINB & (1<<PB5)) ) DDRB &= ~(1<<PB5); // SCL <-- Open
    txdtmp = ((slvdat & 0x1F) << 3);
    txdtmp |= 0x05;
    for(i=8; i--;) {
        DDRB |= (1<<PB5); // SCL <-- Low
        if(txdtmp & 0x80) {
            DDRB &= ~(1<<PB3); // SDA <-- Open
            DDRB &= ~(1<<PB3); // SDA <-- Open
            if( !(PINB & (1<<PB3)) ) goto t4; // SDA==0
        }else{
            DDRB |= (1<<PB3); // SDA <-- Low
        }
        txdtmp <<= 1;
        DDRB &= ~(1<<PB5); // SCL <-- Open
        while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
    }
    DDRB |= (1<<PB3); // SDA <-- Low
    DDRB |= (1<<PB3); // SDA <-- Low
    DDRB |= (1<<PB5); // SCL <-- Low, Start Condition
    DDRB &= ~(1<<PB3); // SDA <-- Open
    DDRB &= ~(1<<PB3); // SDA <-- Open
    if( !(PINB & (1<<PB3)) ) goto t4; // SDA==0
    DDRB &= ~(1<<PB5); // SCL <-- Open
    while( !(PINB & (1<<PB5)) ) ; // wait for SCL==1
}

PROGMEM char headmes[] = "avr HM-monitor\n";

int main(void) {
    uchar ch;

    coninit();
    sei();

ts: while(1) {
        ch = coninp();
        if(ch == 0x1B) break; // esc
        conout(ch);
        if(ch != '\n') conout(ch); // 0x0A
    }
    crlf();
    mesot((char *)headmes);
    while(1) {
montop: conout('.');
        ch = txtin();
        if(ch == 0x03) goto ts; // ^C
        if(ch == 'I') { WORD adr;
            adr = expr1(&ch);
            if(ch < 0x20) conout(' ');
            ladr(adr);
            conout('=');
            lbyte(_MMIO_BYTE(adr)); // 0x20-FF:IO 0x0100-04FF:RAM
            if(ch == '\r') crlf();
        }else if(ch == 'J') { uchar usmrxd=0, usmtxd=0, usslvst, usmsts=0;

            crlf();
termemu:    usslvst = getslvsts() ^ 0xC0;
            if(usmsts & (1<<7)) {
                if( !conots()) {
                    conout(usmrxd);
                    usmsts &= ~(1<<7);
                }
            }else{
                if(usslvst & (1<<7)) {
                    usmrxd = getslvdat();
                    if( !conots()) {
                        conout(usmrxd);
                    }else{
                        usmsts |= (1<<7);
                    }
                }
            }
            if(usmsts & (1<<6)) {
                if( !(usslvst & (1<<6)) ) {
                    putslvdat(usmtxd);
                    usmsts &= ~(1<<6);
                }
            }else{
                if( conins()) {
                    usmtxd = coninp();
                    if(usmtxd == 0x1A) goto montop;
                    if( !(usslvst & (1<<6)) ) {
                        putslvdat(usmtxd);
                    }else{
                        usmsts |= (1<<6);
                    }
                }
            }
            goto termemu;

        }else if(ch == 'K') { uchar cmnd;
            cmnd = expr1(&ch) & 0xFF;
            putslvcmnd(cmnd);
            conout('=');
            lbyte(getslvsts());
            conout(',');
            lbyte(getsphsts());
            conout(' ');

        }else{
            if(ch == '\r') crlf();
            if(ch == '\n') conout(' ');
            conout('x');
            lbyte(ch);
        }
    }
}

/* check register save(push,pop) in MtestASM.S by interrupt */
void rxrdyint0() {
    /*if(UCSR0A & (1<<RXC0)) {
        PORTB |= (1<<PB4);
        if(consts >= 3) consts = 2;
        conibf[consts++] = UDR0;
        if(consts >= 3) UCSR0B &= ~(1<<RXCIE0);
    }*/
}
